#include <Wire.h> 
#include "LiquidCrystal_I2C.h"


LiquidCrystal_I2C lcd(0x27,2,1,0,4,5,6,7,3,POSITIVE);  // Set the LCD I2C address
void setup()
{
	lcd.begin(16,2);               // initialize the lcd 

  lcd.home ();  
	lcd.print(F("K9JM RF Voltmtr"));
	lcd.setCursor(2,1);
	lcd.print(F("May 28, 2015"));
	analogReference(EXTERNAL);
	delay(1000);
  /* add setup code here */

}


void loop()
{
	uint16_t sum = 0;
	const uint16_t max = 50;
	for (uint8_t i = 0 ; i < max ; ++i)
	{
		sum += analogRead(A0);
	}
	lcd.home();
	lcd.clear();
	double db = (97.00 * sum / (1023.0 * max)) - 84.00;
	double voltage = pow(10.00, db/20.00)/4.466836;
	if (voltage < .001){
		voltage *= 1000;
		lcd.print(voltage, 3);
		lcd.print(F("mV "));
	}
	else {
		lcd.print(voltage, 4);
		lcd.print(F("V "));
	}
	double power = voltage * voltage * 20.00;
	if (power < .001)
	{
		power *= 1000;
		lcd.print(power, 2);
		lcd.print(F("uw"));
	}
	else
	{
		lcd.print(power, 3);
		lcd.print(F("mw"));
	}
	lcd.setCursor(5,1);
	lcd.print(db,1);
	lcd.print(F("dB"));
	noInterrupts();
	CLKPR = 1 << CLKPCE;
	CLKPR = 4;  // run at 1/16th clock speed
	interrupts();
	delay (40);
  	noInterrupts();
	CLKPR = 1 << CLKPCE;
	CLKPR = 1;  // run at full clock speed
	interrupts();

}
